---
title: PublicKeyCredential.response
slug: Web/API/PublicKeyCredential/response
tags:
  - API
  - Property
  - PublicKeyCredential
  - Reference
  - Web Authentication API
  - WebAuthn
---
<p>{{APIRef("Web Authentication API")}}{{securecontext_header}}</p>

<p>The <strong><code>response</code></strong> read-only property of the {{domxref("PublicKeyCredential")}} interface is an {{domxref("AuthenticatorResponse")}} object which is sent from the authenticator to the user agent for the creation/fetching of credentials. The information contained in this response will be used by the relying party's server to verify the demand is legitimate.</p>

<p>An <code>AuthenticatorResponse</code> is either:</p>

<ul>
 <li>an {{domxref("AuthenticatorAttestationResponse")}} (when the <code>PublicKeyCredential</code> is created via {{domxref("CredentialsContainer.create()")}})</li>
 <li>an {{domxref("AuthenticatorAssertionResponse")}} (when the <code>PublicKeyCredential</code> is obtained via {{domxref("CredentialsContainer.get()")}}).</li>
</ul>

<p>In order to validate the <em>creation</em> of credentials, a relying party's server needs both:</p>

<ul>
 <li>this response</li>
 <li>the extensions of the client (given by {{domxref("PublicKeyCredential.getClientExtensionResults()")}}) to validate the demand.</li>
</ul>

<div class="notecard note">
<p><strong>Note:</strong> When validating the fetching of existing credentials, the whole <code>PublicKeyCredential</code> object and the client extensions are necessary for the relying party's server.</p>
</div>

<div class="note">
<p><strong>Note:</strong> This property may only be used in top-level contexts and will not be available in an {{HTMLElement("iframe")}} for example.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>response</em> = <em>publicKeyCredential</em>.response</pre>

<h3 id="Value">Value</h3>

<p>An {{domxref("AuthenticatorResponse")}} object containing the data a relying party's script will receive and which should be sent to the relying party's server in order to validate the demand for creation or fetching. This object contains data from the client ({{domxref("AuthenticatorResponse/clientDataJSON")}}) and from the authenticator.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var options = {
  challenge: new Uint8Array(16) /* from the server */,
  rp: {
    name: "Example CORP",
    id  : "login.example.com"
  },
  user: {
    id: new Uint8Array(16) /* from the server */,
    name: "jdoe@example.com",
    displayName: "John Doe"
  },
  pubKeyCredParams: [
    {
      type: "public-key",
      alg: -7
    }
  ]
};

navigator.credentials.create({  publickey: options })
  .then(function (pubKeyCredential) {
    var response = pubKeyCredential.response;
    var clientExtResults = pubKeyCredential.getClientExtensionResults();
    // Send response and client extensions to the server so that it can validate
    // and create credentials

}).catch(function (err) {
  // Deal with any error
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebAuthn','#dom-publickeycredential-response','response')}}</td>
   <td>{{Spec2('WebAuthn')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PublicKeyCredential.response")}}</p>
